package com.usky.fire.controller.web;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.usky.common.core.bean.ApiResult;
import com.usky.common.core.util.StringUtils;
import com.usky.fire.domain.PatrolInspectionAttendance;
import com.usky.fire.service.PatrolInspectionAttendanceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Map;


/**
 * <p>
 * 签到、签退信息记录表 前端控制器
 * </p>
 *
 * @author fu
 * @since 2024-02-05
 */
@RestController
@RequestMapping("/patrolInspectionAttendance")
public class PatrolInspectionAttendanceController {
    @Autowired
    private PatrolInspectionAttendanceService patrolInspectionAttendanceService;
    /**
     * 分页查询签到记录
     * @param
     * @param
     * @return
     */
    @GetMapping("/pageQuery")
    public ApiResult<IPage<Map<String, Object>>> pageQuery(@RequestParam(value = "pageNum", required = false, defaultValue = "1") Integer pageNum,
                                                           @RequestParam(value = "pageSize", required = false, defaultValue = "10") Integer pageSize,
                                                           @RequestParam(value = "typeId", required = false, defaultValue = "") Integer typeId,
                                                           @RequestParam(value = "operator",required = false, defaultValue = "") String operator,
                                                           @RequestParam(value = "startTime", required = false)String startTimeStr,
                                                           @RequestParam(value = "endTime", required = false)String endTimeStr) {
        LocalDateTime startTime = StringUtils.isNotBlank(startTimeStr) ?
                LocalDateTime.parse(startTimeStr, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")) :
                null;
        LocalDateTime endTime = StringUtils.isNotBlank(endTimeStr) ?
                LocalDateTime.parse(endTimeStr, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")) :
                LocalDateTime.now();

        return ApiResult.success(patrolInspectionAttendanceService.pageList(pageNum,pageSize,typeId,operator,startTime,endTime));
    }

    /**
     * 新增
     * @param patrolInspectionAttendance
     * @return
     */
    @PostMapping("/add")
    public ApiResult<Void> add(@RequestBody PatrolInspectionAttendance patrolInspectionAttendance){
        patrolInspectionAttendanceService.add(patrolInspectionAttendance);
        return ApiResult.success();
    }
}

